# Define installation type
option(OCPBASIC_DO_LOCAL_INSTALL "Do a local installation" ON)

option(IPBASIC_USE_HSL "USE HSL lib" OFF)

# Linear algebra backend options
set(LAPACK_WRAPPER_USE_BACKEND "LAPACK_WRAPPER_USE_LAPACK" CACHE STRING "Select LAPACK backend")
set_property(CACHE LAPACK_WRAPPER_USE_BACKEND PROPERTY STRINGS 
    "LAPACK_WRAPPER_USE_LAPACK" 
    "LAPACK_WRAPPER_USE_OPENBLAS" 
    "LAPACK_WRAPPER_USE_MKL"
)

# Eigenvalue calculation options
set(OCPBASIC_EIGENVAL_BACKEND "OCPBASIC_USE_EIGENVAL_LAPACK_WRAPPER" CACHE STRING "Select Eigenvalue backend")
set_property(CACHE OCPBASIC_EIGENVAL_BACKEND PROPERTY STRINGS 
    "OCPBASIC_USE_EIGENVAL_LAPACK_WRAPPER" 
    "OCPBASIC_USE_EIGENVAL_SYM" 
    "OCPBASIC_USE_EIGENVAL_OWN"
)

# Define additional linked libraries
option(OCPBASIC_ADD_LINKED_LIBS "Use added libs." OFF)
set(ADD_LINKED_LIBS "-lgfortran" CACHE STRING "Additional linked libraries")
set(ADD_INCLUDE_PATHS "" CACHE STRING "Additional include paths")

# Set local installation path
if(OCPBASIC_DO_LOCAL_INSTALL)
    set(OCPBASIC_LOCAL_PATH ${CMAKE_CURRENT_SOURCE_DIR})
else()
    set(OCPBASIC_LOCAL_PATH "/usr/")
endif()

# Include and library paths for external dependencies
set(MKL_INCLUDE_PATH "/usr/include/mkl")
set(MKL_PATH_LIBS "-L/usr/lib/x86_64-linux-gnu/ -lmkl_intel_lp64 -lmkl_intel_thread -lmkl_core -lmkl_rt -liomp5")

set(OPENBLAS_INCLUDE_PATH "/usr/include/x86_64-linux-gnu/openblas-pthread")
set(OPENBLAS_PATH_LIBS "-L/usr/lib/x86_64-linux-gnu -lopenblas")

set(BLAS_INCLUDE_PATH "/usr/include/x86_64-linux-gnu")
set(BLAS_PATH_LIBS "-L/usr/lib/x86_64-linux-gnu -lblas")

set(LAPACK_INCLUDE_PATH "/usr/include/x86_64-linux-gnu")
set(LAPACK_PATH_LIBS "-L/usr/lib/x86_64-linux-gnu -llapack")

set(HSL_PATH_LIBS "-L/usr/local/lib/ -lhsl")
