
###############################################################
#                        SET DEFINES                          #
###############################################################

#
# Define if the command "make insatll" does a local installation:
# Comment this line for system installation on linux.
#
# The variable OCPBASIC_LOCAL_PATH in the SET PATH section is
# the installation path.
#
#DEFINES += OCPBASIC_DO_LOCAL_INSTALL

#
#  Define used linear Algebra.
#
# Only supported by lapack_wrapper:
#  LAPACK_WRAPPER_USE_ACCELERATE, LAPACK_WRAPPER_USE_ATLAS,
#
# Currently supported values by IPbasic and OCPbasic:
#  LAPACK_WRAPPER_USE_LAPACK, LAPACK_WRAPPER_USE_OPENBLAS, 
#  LAPACK_WRAPPER_USE_MKL
#
# At least one must be set!
#
DEFINES += LAPACK_WRAPPER_USE_OPENBLAS

#
# Define use of hsl MA57 and MA48. Make sure a libhsl.so
# with all methods of MA57 and MA48 is installed to your
# system.
#
#DEFINES += IPBASIC_USE_HSL

#
# Values:
# OCPBASIC_USE_EIGENVAL_LAPACK_WRAPPER, OCPBASIC_USE_EIGENVAL_SYM, OCPBASIC_USE_EIGENVAL_OWN
#
# At least one must be set!
#
DEFINES += OCPBASIC_USE_EIGENVAL_LAPACK_WRAPPER

#
# Define use of additional linked libs.
# The variable ADD_LINKED_LIBS defines the added libraries.
#
#DEFINES += OCPBASIC_ADD_LINKED_LIBS

###############################################################
#                         SET PATH                            #
###############################################################
#
# This is the local the installation path.
#
OCPBASIC_LOCAL_PATH = $$PWD

#
# Additional linked libs:
#
ADD_LINKED_LIBS = -lgfortran

#
# Define lib and include path for blas and lapack:
#
BLAS_INCLUDE_PATH = /usr/include/x86_64-linux-gnu/

BLAS_PATH_LIBS = -L/usr/lib/x86_64-linux-gnu/ -lblas

LAPACK_INCLUDE_PATH = /usr/include/x86_64-linux-gnu/

LAPACK_PATH_LIBS = -L/usr/lib/x86_64-linux-gnu/ -llapack

#
# Define lib and include path for Openblas:
#
OPENBLAS_INCLUDE_PATH = /usr/include/x86_64-linux-gnu/openblas-pthread/

OPENBLAS_PATH_LIBS = -L/usr/lib/x86_64-linux-gnu/ \
                     -lopenblas

#
# Define lib and include path for intel mkl:
#
MKL_INCLUDE_PATH = /usr/include/mkl/

MKL_PATH_LIBS = -L/usr/lib/x86_64-linux-gnu/ \
                -lmkl_intel_lp64 \
                -lmkl_intel_thread \
                -lmkl_core \
                -lmkl_rt \
                -liomp5

#
# Define lib path for hsl:
#
HSL_PATH_LIBS = -L/usr/lib/ -lhsl
