/*--------------------------------------------------------------------------*\
 |                                                                          |
 |  Copyright (C) 2019                                                      |
 |                                                                          |
 |      Enrico Bertolazzi (1) & Andreas Huber (2)                           |
 |      (1) Dipartimento di Ingegneria Industriale                          |
 |          Universita` degli Studi di Trento                               |
 |          email: enrico.bertolazzi@unitn.it                               |
 |      (2) Fakultät für Luft- und Raumfahrttechnik                         |
 |          Universität der Bundeswehr München                              |
 |          email: info@ocpbasic.com                                        |
\*--------------------------------------------------------------------------*/

/*
 * Commercial license:
 *
 * To get more information about the commercial licence and the commercial use of OCPbasic and IPbasic please contact
 *      info@ocpbasic.com
 *
 * Open source license: (LGPLv3)
 *
 * This library is free software; you can redistribute it and/or modify it under the terms of
 * the GNU Lesser General Public License as published by the Free Software Foundation;
 * either version 3.0 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with this library;
 * if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

/**
 * @file IPbasic_Myfunction.cpp
 * Implementation of the class MyFunction.
 * You can find further informationen in the documentation of the class MyFunction.
 *
 * @author A. Huber
 * @since 14.08.2017
 */

#include "IPbasic_Myfunction.h"

namespace IPbasic
{

    MyFunction::MyFunction()
        : externalFunctionAssigned(false)
    {
        this->externalFunction = MyFunction::DefaultFunction;
    }

    MyFunction::MyFunction(MyFunctionPtr function)
        : externalFunctionAssigned(true)
        , externalFunction(function)
    {
    }

    MyFunction::~MyFunction()
    {
    }

    void MyFunction::setExternalFunction(MyFunctionPtr function)
    {
        this->externalFunction         = function;
        this->externalFunctionAssigned = true;
    }

    void MyFunction::runExternalFunction(string_type const & String)
    {
        this->externalFunction(String);
    }

    void MyFunction::DefaultFunction(string_type const &)
    {
    }

} // namespace IPbasic
