/*--------------------------------------------------------------------------*\
 |                                                                          |
 |  Copyright (C) 2019                                                      |
 |                                                                          |
 |      Enrico Bertolazzi (1) & Andreas Huber (2)                           |
 |      (1) Dipartimento di Ingegneria Industriale                          |
 |          Universita` degli Studi di Trento                               |
 |          email: enrico.bertolazzi@unitn.it                               |
 |      (2) Fakultät für Luft- und Raumfahrttechnik                         |
 |          Universität der Bundeswehr München                              |
 |          email: info@ocpbasic.com                                        |
\*--------------------------------------------------------------------------*/

/*
 * Commercial license:
 *
 * To get more information about the commercial licence and the commercial use of OCPbasic and IPbasic please contact
 *      info@ocpbasic.com
 *
 * Open source license: (LGPLv3)
 *
 * This library is free software; you can redistribute it and/or modify it under the terms of
 * the GNU Lesser General Public License as published by the Free Software Foundation;
 * either version 3.0 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with this library;
 * if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

///
/// file: IPbasic.cpp
///

#include "IPbasic.h"
#include "Errors/IPbasic_Errors.h"

#include <limits>

#ifdef __GCC__
#pragma GCC diagnostic ignored "-Wglobal-constructors"
#endif
#ifdef __clang__
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif

namespace IPbasic
{
    using std::abs;
    using std::fpclassify;
    using std::lower_bound;
    using std::numeric_limits;
    using std::sqrt;

    real_type const machepsi     = numeric_limits<real_type>::epsilon();
    real_type const machepsi10   = 10 * machepsi;
    real_type const machepsi100  = 100 * machepsi;
    real_type const machepsi1000 = 1000 * machepsi;
    real_type const sqrtMachepsi = sqrt(machepsi);

} // namespace IPbasic

// EOF: IPbasic.cpp
