#-------------------------------------------------
#
# Project created by QtCreator 2018-09-20T09:51:35
#
#-------------------------------------------------

QT     -= core gui
CONFIG -= qt

TARGET = IPbasic
TEMPLATE = lib

include($$PWD/../../config.pri)
include($$PWD/../../versionNumbers.pri)

VERSION = $$VERSION_NUMBER_IPBASIC

#CONFIG -= c++11
#CONFIG += no-c++11 no-c++14
#QMAKE_CXXFLAGS += -std=c++98 -pedantic
#QMAKE_CXXFLAGS_GNUCXX11 = -std=c++98

win32:CONFIG(release, debug|release): LIBS += $$OUT_PWD/../lapack_wrapper/release/lapack_wrapper.dll
else:win32:CONFIG(debug, debug|release): LIBS += $$OUT_PWD/../lapack_wrapper/debug/lapack_wrapper.dll
else:unix: LIBS += -L$$OUT_PWD/../lapack_wrapper/ -llapack_wrapper

INCLUDEPATH += $$PWD/../
DEPENDPATH += $$PWD/../

contains(DEFINES, LAPACK_WRAPPER_USE_MKL) {
INCLUDEPATH += $$MKL_INCLUDE_PATH
LIBS += $$MKL_PATH_LIBS
}
contains(DEFINES, LAPACK_WRAPPER_USE_OPENBLAS) {
INCLUDEPATH += $$OPENBLAS_INCLUDE_PATH
LIBS += $$OPENBLAS_PATH_LIBS
}
contains(DEFINES, LAPACK_WRAPPER_USE_LAPACK) {
INCLUDEPATH += $$BLAS_INCLUDE_PATH
INCLUDEPATH += $$LAPACK_INCLUDE_PATH
LIBS += $$BLAS_PATH_LIBS
LIBS += $$LAPACK_PATH_LIBS
}

contains (DEFINES, IPBASIC_USE_HSL){
    LIBS += $$HSL_PATH_LIBS
}

contains(DEFINES, OCPBASIC_ADD_LINKED_LIBS) {
    LIBS += $$ADD_LINKED_LIBS
}

#QMAKE_CXXFLAGS += -fopenmp
#QMAKE_LFLAGS += -fopenmp

DEFINES += IPbasic_LIBRARY

HEADERS += \
    IPbasic_Config.h \
    IPbasic_Data.h \
    IPbasic_NLP.h \
    IPbasic_KKTSystem.h \
    IPbasic_Parameter.h \
    IPbasic_Solver.h \
    IPbasic_Timings.h \
    IPbasic.h \
    Errors/IPbasic_Errors.h \
    Errors/IPbasic_Myfunction.h \
    Errors/mycolordef.h \
    LinSolvers/IPbasic_LinearSolver_interface.h \
    LinSolvers/IPbasic_LinearSolver_MA48.h \
    LinSolvers/IPbasic_LinearSolver_MA57.h \
    LineSearch/IPbasic_Armijo.h \
    LineSearch/IPbasic_L1_Penalty.h \
    LineSearch/IPbasic_LineSearch.h \
    LineSearch/IPbasic_LineSearchFunction.h \
    interfaces/HSL/hslsolver.h \
    interfaces/HSL/cppma48.h \
    interfaces/HSL/cppma57.h \
    interfaces/HSL/hsl.h \

SOURCES += \
    IPbasic_Data.cpp \
    IPbasic_KKTSystem.cpp \
    IPbasic_Solver.cpp \
    IPbasic_Timings.cpp \
    IPbasic.cpp \
    Errors/IPbasic_Errors.cpp \
    Errors/IPbasic_Myfunction.cpp \
    Errors/mycolordef.cpp \
    LineSearch/IPbasic_Armijo.cpp \
    LineSearch/IPbasic_L1_Penalty.cpp \
    LineSearch/IPbasic_LineSearch.cpp \
    LineSearch/IPbasic_LineSearchFunction.cpp \
    interfaces/HSL/cppma48.cpp \
    interfaces/HSL/cppma57.cpp \


MAIN_HEADERS += \
    IPbasic_Data.h \
    IPbasic_NLP.h \
    IPbasic_KKTSystem.h \
    IPbasic_Parameter.h \
    IPbasic_Solver.h \
    IPbasic_Timings.h \
    IPbasic.h \
    # IPbasic_Config.h \

DEFUALT_CONFIG_HEADERS += \
    configHeaders/Default/IPbasic_Config.h

HSL_CONFIG_HEADERS += \
    configHeaders/HSL/IPbasic_Config.h

ERROR_HEADERS += \
    Errors/IPbasic_Errors.h \
    Errors/IPbasic_Myfunction.h \
    Errors/mycolordef.h

HSL_IFACE_HEADERS += \
    interfaces/HSL/hslsolver.h \
    interfaces/HSL/cppma48.h \
    interfaces/HSL/cppma57.h \

LINE_SEARCH_HEADERS += \
    LineSearch/IPbasic_Armijo.h \
    LineSearch/IPbasic_L1_Penalty.h \
    LineSearch/IPbasic_LineSearch.h \
    LineSearch/IPbasic_LineSearchFunction.h
    
LIN_SOLVERS_HEADERS += \
    LinSolvers/IPbasic_LinearSolver_interface.h \
    LinSolvers/IPbasic_LinearSolver_MA48.h \
    LinSolvers/IPbasic_LinearSolver_MA57.h \

contains(DEFINES, OCPBASIC_DO_LOCAL_INSTALL) { # Local installation:
    target.path = $$OCPBASIC_LOCAL_PATH/lib
    INSTALLS += target
    main_header_files.files                   = $$MAIN_HEADERS
    main_header_files.path                    = $$OCPBASIC_LOCAL_PATH/include/IPbasic/
    # Install config_header_files:
    config_header_files.path                  = $$OCPBASIC_LOCAL_PATH/include/IPbasic/
    # Select correct header to install:
    contains(DEFINES, IPBASIC_USE_HSL) {
    config_header_files.files                 = $$HSL_CONFIG_HEADERS
    } else {
    config_header_files.files                 = $$DEFUALT_CONFIG_HEADERS
    }
    error_header_files.files                  = $$ERROR_HEADERS
    error_header_files.path                   = $$OCPBASIC_LOCAL_PATH/include/IPbasic/Errors/
    hsl_iface_files.files                     = $$HSL_IFACE_HEADERS
    hsl_iface_files.path                      = $$OCPBASIC_LOCAL_PATH/include/IPbasic/interfaces/HSL/
    line_search_files.files                   = $$LINE_SEARCH_HEADERS
    line_search_files.path                    = $$OCPBASIC_LOCAL_PATH/include/IPbasic/LineSearch
    lin_solvers_files.files                   = $$LIN_SOLVERS_HEADERS
    lin_solvers_files.path                    = $$OCPBASIC_LOCAL_PATH/include/IPbasic/LinSolvers
    INSTALLS += main_header_files \
                config_header_files \
                error_header_files \
                hsl_iface_files \
                line_search_files \
                lin_solvers_files \
} else { # System wide installation:
unix {
    target.path = /usr/lib
    INSTALLS += target
    main_header_files.files                   = $$MAIN_HEADERS
    main_header_files.path                    = /usr/include/IPbasic/
    # Install config_header_files:
    config_header_files.path                  = /usr/include/IPbasic/
    # Select correct header to install:
    contains(DEFINES, IPBASIC_USE_HSL) {
    config_header_files.files                 = $$HSL_CONFIG_HEADERS
    } else {
    config_header_files.files                 = $$DEFUALT_CONFIG_HEADERS
    }
    error_header_files.files                  = $$ERROR_HEADERS
    error_header_files.path                   = /usr/include/IPbasic/Errors/
    hsl_iface_files.files                     = $$HSL_IFACE_HEADERS
    hsl_iface_files.path                      = /usr/include/IPbasic/interfaces/HSL/
    line_search_files.files                   = $$LINE_SEARCH_HEADERS
    line_search_files.path                    = /usr/include/IPbasic/LineSearch
    lin_solvers_files.files                   = $$LIN_SOLVERS_HEADERS
    lin_solvers_files.path                    = /usr/include/IPbasic/LinSolvers
    INSTALLS += main_header_files \
                config_header_files \
                error_header_files \
                hsl_iface_files \
                line_search_files \
                lin_solvers_files \
}
}
