#-------------------------------------------------
#
# Project created by QtCreator 2018-09-20T09:51:35
#
#-------------------------------------------------

QT     -= core gui
CONFIG -= qt

TARGET = OCPbasic
TEMPLATE = lib

include($$PWD/../../config.pri)
include($$PWD/../../versionNumbers.pri)

VERSION = $$VERSION_NUMBER_OCPBASIC

#QMAKE_CXXFLAGS += -fopenmp
#QMAKE_LFLAGS += -fopenmp

win32:CONFIG(release, debug|release): LIBS += $$OUT_PWD/../lapack_wrapper/release/lapack_wrapper.dll
else:win32:CONFIG(debug, debug|release): LIBS += $$OUT_PWD/../lapack_wrapper/debug/lapack_wrapper.dll
else:unix: LIBS += -L$$OUT_PWD/../lapack_wrapper/ -llapack_wrapper

win32:CONFIG(release, debug|release): LIBS += $$OUT_PWD/../IPbasic/release/IPbasic.dll
else:win32:CONFIG(debug, debug|release): LIBS += $$OUT_PWD/../IPbasic/debug/IPbasic.dll
else:unix: LIBS += -L$$OUT_PWD/../IPbasic/ -lIPbasic

INCLUDEPATH += $$PWD/../
DEPENDPATH += $$PWD/../

contains(DEFINES, LAPACK_WRAPPER_USE_MKL) {
INCLUDEPATH += $$MKL_INCLUDE_PATH
LIBS += $$MKL_PATH_LIBS
}
contains(DEFINES, LAPACK_WRAPPER_USE_OPENBLAS) {
INCLUDEPATH += $$OPENBLAS_INCLUDE_PATH
LIBS += $$OPENBLAS_PATH_LIBS
}
contains(DEFINES, LAPACK_WRAPPER_USE_LAPACK) {
INCLUDEPATH += $$BLAS_INCLUDE_PATH
INCLUDEPATH += $$LAPACK_INCLUDE_PATH
LIBS += $$BLAS_PATH_LIBS
LIBS += $$LAPACK_PATH_LIBS
}

contains (DEFINES, IPBASIC_USE_HSL){
    LIBS += $$HSL_PATH_LIBS
}

contains(DEFINES, OCPBASIC_ADD_LINKED_LIBS) {
    LIBS += $$ADD_LINKED_LIBS
}

DEFINES += OCPbasic_LIBRARY

SOURCES += \
    problem.cpp \
    solution.cpp \
    Discretization/DiscreteDimension.cpp \
    Discretization/Discretization.cpp \
    Discretization/trapez.cpp \
    Optimizer/InteriorPointMethod.cpp \
    Optimizer/InteriorPointMethod/ip_nlp.cpp \
    Optimizer/InteriorPointMethod/ip_solver.cpp \
    OCP_Timings.cpp \
    linalg/collectormatrix.cpp \
    linalg/sparsematrix.cpp \
    linalg/OCPbasic.cpp \
    linalg/OCPbasic_SymEigenValues.cpp \
    linalg/BandedLU.cpp \
    linalg/DenseLU.cpp \
    linalg/LapackKKTSolver.cpp


HEADERS += \
    problem.h \
    solution.h \
    OCPbasic_config.h \
    Discretization/trapez.h \
    Discretization/DiscreteDefs.h \
    Discretization/DiscreteDimension.h \
    Discretization/Discretization.h \
    Optimizer/Optimizer.h \
    Optimizer/InteriorPointMethod.h \
    Optimizer/InteriorPointMethod/ip_nlp.h \
    Optimizer/InteriorPointMethod/ip_solver.h \
    OCP_Params.h \
    OCP_Timings.h \
    linalg/sparsematrix.h \
    linalg/collectormatrix.h \
    linalg/OCPbasic.h \
    linalg/OCPbasic_HouseholderQR.h \
    linalg/OCPbasic_SymEigenValues.h \
    linalg/BandedLU.h \
    linalg/DenseLU.h \
    linalg/LapackKKTSolver.h \
    linalg/OCPbasic_lapack_blas.h


MAIN_HEADERS += \
    problem.h \
    solution.h \
    OCP_Params.h \
    OCP_Timings.h \
    #OCPbasic_config.h \

EIGEN_LW_CONFIG_HEADERS += \
    configHeaders/Eigenvalues_lapack_wrapper/OCPbasic_config.h

EIGEN_SYM_CONFIG_HEADERS += \
    configHeaders/Eigenvalues_Own/OCPbasic_config.h

EIGEN_OWN_CONFIG_HEADERS += \
    configHeaders/Eigenvalues_Sym/OCPbasic_config.h

OPT_HEADERS += \
    Optimizer/Optimizer.h \
    Optimizer/InteriorPointMethod.h

DISKR_HEADERS += \
    Discretization/trapez.h \
    Discretization/DiscreteDefs.h \
    Discretization/DiscreteDimension.h \
    Discretization/Discretization.h \

LINALG_HEADERS += \
    linalg/sparsematrix.h \
    linalg/collectormatrix.h \
    linalg/OCPbasic.h \
    linalg/OCPbasic_HouseholderQR.h \
    linalg/OCPbasic_SymEigenValues.h \
    linalg/BandedLU.h \
    linalg/DenseLU.h \
    linalg/LapackKKTSolver.h \

contains(DEFINES, OCPBASIC_DO_LOCAL_INSTALL) { # Local installation:
    target.path = $$OCPBASIC_LOCAL_PATH/lib
    INSTALLS += target
    main_header_files.files   = $$MAIN_HEADERS
    main_header_files.path    = $$OCPBASIC_LOCAL_PATH/include/OCPbasic/
    # Install config_header_files:
    config_header_files.path                  = $$OCPBASIC_LOCAL_PATH/include/OCPbasic/
    # Select correct header to install:
    contains(DEFINES, OCPBASIC_USE_EIGENVAL_LAPACK_WRAPPER) {
    config_header_files.files                 = $$EIGEN_LW_CONFIG_HEADERS
    }
    contains(DEFINES, OCPBASIC_USE_EIGENVAL_SYM) {
    config_header_files.files                 = $$EIGEN_SYM_CONFIG_HEADERS
    }
    contains(DEFINES, OCPBASIC_USE_EIGENVAL_OWN) {
    config_header_files.files                 = $$EIGEN_OWN_CONFIG_HEADERS
    }
    opt_header_files.files    = $$OPT_HEADERS
    opt_header_files.path     = $$OCPBASIC_LOCAL_PATH/include/OCPbasic/Optimizer
    diskr_header_files.files  = $$DISKR_HEADERS
    diskr_header_files.path   = $$OCPBASIC_LOCAL_PATH/include/OCPbasic/Discretization
    linalg_header_files.files = $$LINALG_HEADERS
    linalg_header_files.path  = $$OCPBASIC_LOCAL_PATH/include/OCPbasic/linalg
    INSTALLS += main_header_files \
                config_header_files \
                opt_header_files \
                diskr_header_files \
                linalg_header_files \
} else { # System wide installation:
unix {
    target.path = /usr/lib
    INSTALLS += target
    main_header_files.files   = $$MAIN_HEADERS
    main_header_files.path    = /usr/include/OCPbasic/
    # Install config_header_files:
    config_header_files.path                  = /usr/include/OCPbasic/
    # Select correct header to install:
    contains(DEFINES, OCPBASIC_USE_EIGENVAL_LAPACK_WRAPPER) {
    config_header_files.files                 = $$EIGEN_LW_CONFIG_HEADERS
    }
    contains(DEFINES, OCPBASIC_USE_EIGENVAL_SYM) {
    config_header_files.files                 = $$EIGEN_SYM_CONFIG_HEADERS
    }
    contains(DEFINES, OCPBASIC_USE_EIGENVAL_OWN) {
    config_header_files.files                 = $$EIGEN_OWN_CONFIG_HEADERS
    }
    opt_header_files.files    = $$OPT_HEADERS
    opt_header_files.path     = /usr/include/OCPbasic/Optimizer
    diskr_header_files.files  = $$DISKR_HEADERS
    diskr_header_files.path   = /usr/include/OCPbasic/Discretization
    linalg_header_files.files = $$LINALG_HEADERS
    linalg_header_files.path  = /usr/include/OCPbasic/linalg
    INSTALLS += main_header_files \
                config_header_files \
                opt_header_files \
                diskr_header_files \
                linalg_header_files \
}
}
