#-------------------------------------------------
#
# Project created by QtCreator 2018-09-20T09:51:35
#
#-------------------------------------------------

QT     -= core gui
CONFIG -= qt

TARGET = lapack_wrapper
TEMPLATE = lib

include($$PWD/../../config.pri)
include($$PWD/../../versionNumbers.pri)

VERSION = $$VERSION_NUMBER_LAPACK_WRAPPER

#CONFIG -= c++11
#CONFIG += no-c++11 no-c++14
#QMAKE_CXXFLAGS += -std=c++98 -pedantic
#QMAKE_CXXFLAGS_GNUCXX11 = -std=c++98

#QMAKE_CXXFLAGS += -fopenmp
#QMAKE_LFLAGS += -fopenmp

contains(DEFINES, LAPACK_WRAPPER_USE_MKL) {
INCLUDEPATH += $$MKL_INCLUDE_PATH
LIBS += $$MKL_PATH_LIBS
}
contains(DEFINES, LAPACK_WRAPPER_USE_OPENBLAS) {
INCLUDEPATH += $$OPENBLAS_INCLUDE_PATH
LIBS += $$OPENBLAS_PATH_LIBS
}
contains(DEFINES, LAPACK_WRAPPER_USE_LAPACK) {
INCLUDEPATH += $$BLAS_INCLUDE_PATH
INCLUDEPATH += $$LAPACK_INCLUDE_PATH
LIBS += $$BLAS_PATH_LIBS
LIBS += $$LAPACK_PATH_LIBS
}

contains(DEFINES, OCPBASIC_ADD_LINKED_LIBS) {
    LIBS += $$ADD_LINKED_LIBS
}

DEFINES += lapack_wrapper_LIBRARY

HEADERS += \
    lapack_wrapper_config.hh \
    lapack_wrapper.hh \
    lapack_wrapper++.hh \
    TicToc.hh \
    code/banded.hxx \
    code/blas.hxx \
    code/general_qr.hxx \
    code/general.hxx \
    code/sparse.hxx \
    code/symmetric.hxx \
    code/triangular.hxx \
    code/tridiagonal.hxx \
    code/wrapper.hxx \
    code++/trid.hxx \
    code++/band.hxx \
    code++/block_trid.hxx \
    code++/eig.hxx \
    code++/ls.hxx \
    code++/lu.hxx \
    code++/qn.hxx \
    code++/qr.hxx \
    code++/svd.hxx

SOURCES += \
    lapack_wrapper.cc \
    lapack_wrapper++.cc \
    code/sparse.cxx \
    code/wrapper.cxx \
    code++/band.cxx \
    code++/block_trid.cxx \
    code++/eig.cxx \
    code++/ls.cxx \
    code++/lu.cxx \
    code++/qn.cxx \
    code++/qr.cxx \
    code++/svd.cxx \
    code++/trid.cxx


MAIN_HEADERS += \
    lapack_wrapper.hh \
    lapack_wrapper++.hh \
    TicToc.hh
    # lapack_wrapper_config.hh \

MKL_CONFIG_HEADERS += \
    configHeaders/MKL/lapack_wrapper_config.hh

OPENBLAS_CONFIG_HEADERS += \
    configHeaders/OpenBLAS/lapack_wrapper_config.hh

LAPACK_BLAS_CONFIG_HEADERS += \
    configHeaders/LAPACK_BLAS/lapack_wrapper_config.hh

CODE_HEADERS += \
    code/banded.hxx \
    code/blas.hxx \
    code/general_qr.hxx \
    code/general.hxx \
    code/sparse.hxx \
    code/symmetric.hxx \
    code/triangular.hxx \
    code/tridiagonal.hxx \
    code/wrapper.hxx

CODEPP_HEADERS += \
    code++/trid.hxx \
    code++/band.hxx \
    code++/block_trid.hxx \
    code++/eig.hxx \
    code++/ls.hxx \
    code++/lu.hxx \
    code++/qn.hxx \
    code++/qr.hxx \
    code++/svd.hxx

contains(DEFINES, OCPBASIC_DO_LOCAL_INSTALL) { # Local installation:
    target.path = $$OCPBASIC_LOCAL_PATH/lib
    INSTALLS += target
    main_header_files.files                   = $$MAIN_HEADERS
    main_header_files.path                    = $$OCPBASIC_LOCAL_PATH/include/lapack_wrapper/
    # Install config_header_files:
    config_header_files.path                  = $$OCPBASIC_LOCAL_PATH/include/lapack_wrapper/
    # Select correct header to install:
    contains(DEFINES, LAPACK_WRAPPER_USE_MKL) {
    config_header_files.files                 = $$MKL_CONFIG_HEADERS
    }
    contains(DEFINES, LAPACK_WRAPPER_USE_OPENBLAS) {
    config_header_files.files                 = $$OPENBLAS_CONFIG_HEADERS
    }
    contains(DEFINES, LAPACK_WRAPPER_USE_LAPACK) {
    config_header_files.files                 = $$LAPACK_BLAS_CONFIG_HEADERS
    }
    code_files.files                          = $$CODE_HEADERS
    code_files.path                           = $$OCPBASIC_LOCAL_PATH/include/lapack_wrapper/code/
    codepp_files.files                        = $$CODEPP_HEADERS
    codepp_files.path                         = $$OCPBASIC_LOCAL_PATH/include/lapack_wrapper/code++/
    INSTALLS += main_header_files \
                config_header_files \
                code_files \
                codepp_files \
} else { # System wide installation:
unix {
    target.path = /usr/lib
    INSTALLS += target
    main_header_files.files                   = $$MAIN_HEADERS
    main_header_files.path                    = /usr/include/lapack_wrapper/
    # Install config_header_files:
    config_header_files.path                  = /usr/include/lapack_wrapper/
    # Select correct header to install:
    contains(DEFINES, LAPACK_WRAPPER_USE_MKL) {
    config_header_files.files                 = $$MKL_CONFIG_HEADERS
    }
    contains(DEFINES, LAPACK_WRAPPER_USE_OPENBLAS) {
    config_header_files.files                 = $$OPENBLAS_CONFIG_HEADERS
    }
    contains(DEFINES, LAPACK_WRAPPER_USE_LAPACK) {
    config_header_files.files                 = $$LAPACK_BLAS_CONFIG_HEADERS
    }
    code_files.files                          = $$CODE_HEADERS
    code_files.path                           = /usr/include/lapack_wrapper/code/
    codepp_files.files                        = $$CODEPP_HEADERS
    codepp_files.path                         = /usr/include/lapack_wrapper/code++/
    INSTALLS += main_header_files \
                config_header_files \
                code_files \
                codepp_files \
}
}
